package solutions.bitbadger.documents.scala.tests.integration

import org.junit.jupiter.api.{DisplayName, Test}

import scala.util.Using

@DisplayName("Scala | SQLite: Custom")
class SQLiteCustomIT:

  @Test
  @DisplayName("list succeeds with empty list")
  def listEmpty(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.listEmpty(db) }

  @Test
  @DisplayName("list succeeds with a non-empty list")
  def listAll(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.listAll(db) }

  @Test
  @DisplayName("single succeeds when document not found")
  def singleNone(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.singleNone(db) }

  @Test
  @DisplayName("single succeeds when a document is found")
  def singleOne(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.singleOne(db) }

  @Test
  @DisplayName("nonQuery makes changes")
  def nonQueryChanges(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.nonQueryChanges(db) }

  @Test
  @DisplayName("nonQuery makes no changes when where clause matches nothing")
  def nonQueryNoChanges(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.nonQueryNoChanges(db) }

  @Test
  @DisplayName("scalar succeeds")
  def scalar(): Unit =
    Using(SQLiteDB()) { db => CustomFunctions.scalar(db) }
